/// @cond EO_CXX_EO_IMPL

inline void evas_3d_light::ambient_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_ambient_set(r_, g_, b_, a_));
}

inline void evas_3d_light::ambient_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_ambient_get(r_, g_, b_, a_));
}

inline void evas_3d_light::diffuse_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_diffuse_set(r_, g_, b_, a_));
}

inline void evas_3d_light::diffuse_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_diffuse_get(r_, g_, b_, a_));
}

inline void evas_3d_light::specular_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_specular_set(r_, g_, b_, a_));
}

inline void evas_3d_light::specular_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_specular_get(r_, g_, b_, a_));
}

inline void evas_3d_light::attenuation_set(Evas_Real constant_, Evas_Real linear_, Evas_Real quadratic_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_attenuation_set(constant_, linear_, quadratic_));
}

inline void evas_3d_light::attenuation_get(Evas_Real* constant_, Evas_Real* linear_, Evas_Real* quadratic_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_attenuation_get(constant_, linear_, quadratic_));
}

inline void evas_3d_light::projection_matrix_set(const Evas_Real * matrix_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_matrix_set(matrix_));
}

inline void evas_3d_light::projection_matrix_get(Evas_Real* matrix_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_matrix_get(matrix_));
}

inline void evas_3d_light::projection_perspective_set(Evas_Real fovy_, Evas_Real aspect_, Evas_Real dnear_, Evas_Real dfar_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_perspective_set(fovy_, aspect_, dnear_, dfar_));
}

inline void evas_3d_light::projection_frustum_set(Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_frustum_set(left_, right_, bottom_, top_, dnear_, dfar_));
}

inline void evas_3d_light::projection_ortho_set(Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_ortho_set(left_, right_, bottom_, top_, dnear_, dfar_));
}

inline bool evas_3d_light::directional_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_directional_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_light::directional_set(bool directional_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_directional_set(::efl::eolian::to_c(directional_)));
}

inline Evas_Real evas_3d_light::spot_exponent_get() const
{
   Evas_Real _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_spot_exponent_get());
   return _tmp_ret;
}

inline void evas_3d_light::spot_exponent_set(Evas_Real exponent_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_spot_exponent_set(exponent_));
}

inline Evas_Real evas_3d_light::spot_cutoff_get() const
{
   Evas_Real _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_spot_cutoff_get());
   return _tmp_ret;
}

inline void evas_3d_light::spot_cutoff_set(Evas_Real cutoff_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_spot_cutoff_set(cutoff_));
}

inline bool evas_3d_light::attenuation_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_attenuation_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas_3d_light::attenuation_enable_set(bool enable_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_attenuation_enable_set(::efl::eolian::to_c(enable_)));
}

inline void eo_cxx::evas_3d_light::ambient_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_ambient_set(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_light::ambient_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_ambient_get(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_light::diffuse_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_diffuse_set(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_light::diffuse_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_diffuse_get(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_light::specular_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_specular_set(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_light::specular_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_specular_get(r_, g_, b_, a_));
}

inline void eo_cxx::evas_3d_light::attenuation_set(Evas_Real constant_, Evas_Real linear_, Evas_Real quadratic_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_attenuation_set(constant_, linear_, quadratic_));
}

inline void eo_cxx::evas_3d_light::attenuation_get(Evas_Real* constant_, Evas_Real* linear_, Evas_Real* quadratic_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_attenuation_get(constant_, linear_, quadratic_));
}

inline void eo_cxx::evas_3d_light::projection_matrix_set(const Evas_Real * matrix_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_matrix_set(matrix_));
}

inline void eo_cxx::evas_3d_light::projection_matrix_get(Evas_Real* matrix_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_matrix_get(matrix_));
}

inline void eo_cxx::evas_3d_light::projection_perspective_set(Evas_Real fovy_, Evas_Real aspect_, Evas_Real dnear_, Evas_Real dfar_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_perspective_set(fovy_, aspect_, dnear_, dfar_));
}

inline void eo_cxx::evas_3d_light::projection_frustum_set(Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_frustum_set(left_, right_, bottom_, top_, dnear_, dfar_));
}

inline void eo_cxx::evas_3d_light::projection_ortho_set(Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_projection_ortho_set(left_, right_, bottom_, top_, dnear_, dfar_));
}

inline bool eo_cxx::evas_3d_light::directional_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_directional_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_light::directional_set(bool directional_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_directional_set(::efl::eolian::to_c(directional_)));
}

inline Evas_Real eo_cxx::evas_3d_light::spot_exponent_get() const
{
   Evas_Real _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_spot_exponent_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_light::spot_exponent_set(Evas_Real exponent_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_spot_exponent_set(exponent_));
}

inline Evas_Real eo_cxx::evas_3d_light::spot_cutoff_get() const
{
   Evas_Real _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_spot_cutoff_get());
   return _tmp_ret;
}

inline void eo_cxx::evas_3d_light::spot_cutoff_set(Evas_Real cutoff_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_spot_cutoff_set(cutoff_));
}

inline bool eo_cxx::evas_3d_light::attenuation_enable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_3d_light_attenuation_enable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas_3d_light::attenuation_enable_set(bool enable_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_3d_light_attenuation_enable_set(::efl::eolian::to_c(enable_)));
}

inline ::eo_cxx::evas_3d_light::operator ::evas_3d_light() const
{
   return *static_cast<::evas_3d_light const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas_3d_light::operator ::evas_3d_light&()
{
   return *static_cast<::evas_3d_light*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas_3d_light::operator ::evas_3d_light const&() const
{
   return *static_cast<::evas_3d_light const*>(static_cast<void const*>(this));
}

template <typename T>
void _evas_3d_light_ambient_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   try
      {
         static_cast<T*>(self->this_)->ambient_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_ambient_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   try
      {
         static_cast<T*>(self->this_)->ambient_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_diffuse_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   try
      {
         static_cast<T*>(self->this_)->diffuse_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_diffuse_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   try
      {
         static_cast<T*>(self->this_)->diffuse_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_specular_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
{
   try
      {
         static_cast<T*>(self->this_)->specular_set(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_specular_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
{
   try
      {
         static_cast<T*>(self->this_)->specular_get(r_, g_, b_, a_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_attenuation_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real constant_, Evas_Real linear_, Evas_Real quadratic_)
{
   try
      {
         static_cast<T*>(self->this_)->attenuation_set(constant_, linear_, quadratic_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_attenuation_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* constant_, Evas_Real* linear_, Evas_Real* quadratic_)
{
   try
      {
         static_cast<T*>(self->this_)->attenuation_get(constant_, linear_, quadratic_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_projection_matrix_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Evas_Real * matrix_)
{
   try
      {
         static_cast<T*>(self->this_)->projection_matrix_set(matrix_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_projection_matrix_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real* matrix_)
{
   try
      {
         static_cast<T*>(self->this_)->projection_matrix_get(matrix_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_projection_perspective_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real fovy_, Evas_Real aspect_, Evas_Real dnear_, Evas_Real dfar_)
{
   try
      {
         static_cast<T*>(self->this_)->projection_perspective_set(fovy_, aspect_, dnear_, dfar_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_projection_frustum_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_)
{
   try
      {
         static_cast<T*>(self->this_)->projection_frustum_set(left_, right_, bottom_, top_, dnear_, dfar_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void _evas_3d_light_projection_ortho_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_)
{
   try
      {
         static_cast<T*>(self->this_)->projection_ortho_set(left_, right_, bottom_, top_, dnear_, dfar_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_light_directional_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->directional_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_light_directional_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool directional_)
{
   try
      {
         static_cast<T*>(self->this_)->directional_set(::efl::eolian::to_cxx<bool>(directional_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Real _evas_3d_light_spot_exponent_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Real _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->spot_exponent_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_light_spot_exponent_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real exponent_)
{
   try
      {
         static_cast<T*>(self->this_)->spot_exponent_set(exponent_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Real _evas_3d_light_spot_cutoff_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Real _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->spot_cutoff_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_light_spot_cutoff_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Real cutoff_)
{
   try
      {
         static_cast<T*>(self->this_)->spot_cutoff_set(cutoff_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool _evas_3d_light_attenuation_enable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->attenuation_enable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void _evas_3d_light_attenuation_enable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enable_)
{
   try
      {
         static_cast<T*>(self->this_)->attenuation_enable_set(::efl::eolian::to_cxx<bool>(enable_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_3d_light >
{
   template <typename T>
   struct type
         : virtual operations< ::evas_3d_object >::template type<T>
         , virtual operations< ::evas::common_interface >::template type<T>
   {
      virtual void ambient_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_ambient_set(r_, g_, b_, a_));
      }

      virtual void ambient_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_ambient_get(r_, g_, b_, a_));
      }

      virtual void diffuse_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_diffuse_set(r_, g_, b_, a_));
      }

      virtual void diffuse_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_diffuse_get(r_, g_, b_, a_));
      }

      virtual void specular_set(Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_specular_set(r_, g_, b_, a_));
      }

      virtual void specular_get(Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_specular_get(r_, g_, b_, a_));
      }

      virtual void attenuation_set(Evas_Real constant_, Evas_Real linear_, Evas_Real quadratic_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_attenuation_set(constant_, linear_, quadratic_));
      }

      virtual void attenuation_get(Evas_Real* constant_, Evas_Real* linear_, Evas_Real* quadratic_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_attenuation_get(constant_, linear_, quadratic_));
      }

      virtual void projection_matrix_set(const Evas_Real * matrix_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_projection_matrix_set(matrix_));
      }

      virtual void projection_matrix_get(Evas_Real* matrix_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_projection_matrix_get(matrix_));
      }

      virtual void projection_perspective_set(Evas_Real fovy_, Evas_Real aspect_, Evas_Real dnear_, Evas_Real dfar_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_projection_perspective_set(fovy_, aspect_, dnear_, dfar_));
      }

      virtual void projection_frustum_set(Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_projection_frustum_set(left_, right_, bottom_, top_, dnear_, dfar_));
      }

      virtual void projection_ortho_set(Evas_Real left_, Evas_Real right_, Evas_Real bottom_, Evas_Real top_, Evas_Real dnear_, Evas_Real dfar_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_projection_ortho_set(left_, right_, bottom_, top_, dnear_, dfar_));
      }

      virtual bool directional_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_light_directional_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void directional_set(bool directional_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_directional_set(::efl::eolian::to_c(directional_)));
      }

      virtual Evas_Real spot_exponent_get()
      {
         Evas_Real _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_light_spot_exponent_get());
            return _tmp_ret;
      }

      virtual void spot_exponent_set(Evas_Real exponent_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_spot_exponent_set(exponent_));
      }

      virtual Evas_Real spot_cutoff_get()
      {
         Evas_Real _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_light_spot_cutoff_get());
            return _tmp_ret;
      }

      virtual void spot_cutoff_set(Evas_Real cutoff_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_spot_cutoff_set(cutoff_));
      }

      virtual bool attenuation_enable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_3d_light_attenuation_enable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void attenuation_enable_set(bool enable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_3d_light_attenuation_enable_set(::efl::eolian::to_c(enable_)));
      }

   };
};


#ifdef EVAS_3D_LIGHT_PROTECTED
template<>
struct operation_description_class_size< ::evas_3d_light >
{
   static constexpr int value = 21 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

#else
template<>
struct operation_description_class_size< ::evas_3d_light >
{
   static constexpr int value = 21 + operation_description_class_size<::evas_3d_object >::value + operation_description_class_size<::evas::common_interface >::value;
};

#endif

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas_3d_light>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_evas_3d_light_ambient_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_3d_light_ambient_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_evas_3d_light_ambient_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_3d_light_ambient_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_evas_3d_light_diffuse_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_3d_light_diffuse_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_evas_3d_light_diffuse_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_3d_light_diffuse_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_evas_3d_light_specular_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_3d_light_specular_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_evas_3d_light_specular_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_3d_light_specular_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_evas_3d_light_attenuation_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_3d_light_attenuation_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_evas_3d_light_attenuation_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_3d_light_attenuation_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_evas_3d_light_projection_matrix_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_3d_light_projection_matrix_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_evas_3d_light_projection_matrix_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_3d_light_projection_matrix_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_evas_3d_light_projection_perspective_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_3d_light_projection_perspective_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_evas_3d_light_projection_frustum_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_3d_light_projection_frustum_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_evas_3d_light_projection_ortho_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_3d_light_projection_ortho_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_evas_3d_light_directional_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_3d_light_directional_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_evas_3d_light_directional_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_3d_light_directional_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_evas_3d_light_spot_exponent_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::evas_3d_light_spot_exponent_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_evas_3d_light_spot_exponent_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::evas_3d_light_spot_exponent_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_evas_3d_light_spot_cutoff_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::evas_3d_light_spot_cutoff_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_evas_3d_light_spot_cutoff_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::evas_3d_light_spot_cutoff_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_evas_3d_light_attenuation_enable_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::evas_3d_light_attenuation_enable_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_evas_3d_light_attenuation_enable_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::evas_3d_light_attenuation_enable_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas_3d_object>(), &ops[operation_description_class_size< ::evas_3d_light >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::common_interface>(), &ops[operation_description_class_size< ::evas_3d_light >::value + operation_description_class_size<::evas_3d_object>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::evas_3d_light>)
{
   return (EVAS_3D_LIGHT_CLASS);
}

} } }

/// @endcond

