#ifndef EFL_GENERATED_EVAS_3D_MATERIAL_HH
#define EFL_GENERATED_EVAS_3D_MATERIAL_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_3d_material.eo.h"
}

#include "evas_3d_object.eo.hh"
#include "evas_common_interface.eo.hh"

struct evas_3d_material;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct evas_3d_material
{
   /// @param attrib Material attribute ID.
   /// @param r Red component of the color.
   /// @param g Green component of the color.
   /// @param b Blue component of the color.
   /// @param a Alpha component of the color.
   ///
   void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const;

   /// @param attrib Material attribute ID.
   /// @param[out] r Pointer to receive red component of the color.
   /// @param[out] g Pointer to receive green component of the color.
   /// @param[out] b Pointer to receive blue component of the color.
   /// @param[out] a Pointer to receive alpha component of the color.
   ///
   void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const;

   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   bool enable_get(Evas_3D_Material_Attrib attrib_) const;

   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const;

   /// @param shininess Shininess value.
   ///
   Evas_Real shininess_get() const;

   /// @param shininess Shininess value.
   ///
   void shininess_set(Evas_Real shininess_) const;

   /// @param texture 
   ///
   Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_) const;

   /// @brief Set the texture of the given material.
   ///
   /// You have to enable the desired attribute first.
   ///
   /// @see evas_3d_material_enable_set()
   ///
   /// @ingroup Evas_3D_Material
   ///
   /// @param texture 
   ///
   void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const;



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_MATERIAL_CLASS);
   }

   operator ::evas_3d_material() const;
   operator ::evas_3d_material&();
   operator ::evas_3d_material const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::evas_3d_material*() const { return static_cast<::evas_3d_material*>(static_cast<D const*>(this)->p); }
      operator ::evas_3d_material const*() const { return static_cast<::evas_3d_material const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas_3d_material const*() const { return static_cast<::evas_3d_material const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class evas_3d_material
struct evas_3d_material
      : ::efl::eo::concrete
      , EO_CXX_INHERIT(eo::base)
      , EO_CXX_INHERIT(evas::common_interface)
      , EO_CXX_INHERIT(evas_3d_object)
{
   //@{
   /**
      @brief Constructs a new evas_3d_material object.

      Constructs a new evas_3d_material object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      evas_3d_material my_evas_3d_material(efl::eo::parent = parent_object);
      @endcode

      @see evas_3d_material(Eo* eo)
   */
   explicit evas_3d_material(::efl::eo::parent_type _p)
      : evas_3d_material(_ctors_call(_p))
   {}

   explicit evas_3d_material()
      : evas_3d_material(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_3d_material(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit evas_3d_material(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   evas_3d_material(evas_3d_material const& other)
      : evas_3d_material(eo_ref(other._eo_ptr()))
   {}

   ~evas_3d_material() {}

   /// @param attrib Material attribute ID.
   /// @param r Red component of the color.
   /// @param g Green component of the color.
   /// @param b Blue component of the color.
   /// @param a Alpha component of the color.
   ///
   void color_set(Evas_3D_Material_Attrib attrib_, Evas_Real r_, Evas_Real g_, Evas_Real b_, Evas_Real a_) const;

   /// @param attrib Material attribute ID.
   /// @param[out] r Pointer to receive red component of the color.
   /// @param[out] g Pointer to receive green component of the color.
   /// @param[out] b Pointer to receive blue component of the color.
   /// @param[out] a Pointer to receive alpha component of the color.
   ///
   void color_get(Evas_3D_Material_Attrib attrib_, Evas_Real* r_, Evas_Real* g_, Evas_Real* b_, Evas_Real* a_) const;

   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   bool enable_get(Evas_3D_Material_Attrib attrib_) const;

   /// @param enable Whether to enable the attribute (@c EINA_TRUE), or not (@c EINA_FALSE).
   ///
   void enable_set(Evas_3D_Material_Attrib attrib_, bool enable_) const;

   /// @param shininess Shininess value.
   ///
   Evas_Real shininess_get() const;

   /// @param shininess Shininess value.
   ///
   void shininess_set(Evas_Real shininess_) const;

   /// @param texture 
   ///
   Evas_3D_Texture * texture_get(Evas_3D_Material_Attrib attrib_) const;

   /// @brief Set the texture of the given material.
   ///
   /// You have to enable the desired attribute first.
   ///
   /// @see evas_3d_material_enable_set()
   ///
   /// @ingroup Evas_3D_Material
   ///
   /// @param texture 
   ///
   void texture_set(Evas_3D_Material_Attrib attrib_, Evas_3D_Texture * texture_) const;

   /// A callback was added.
   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_add_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_ADD, priority_,
            &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>,
         EO_BASE_EVENT_CALLBACK_ADD );
   }

   /// A callback was added.
   template <typename T>
   void
   callback_callback_add_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_ADD, info));
   }

   /// A callback was deleted.
   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_DEL, priority_,
            &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>,
         EO_BASE_EVENT_CALLBACK_DEL );
   }

   /// A callback was deleted.
   template <typename T>
   void
   callback_callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_DEL, info));
   }

   /// Clicked Event
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_3D_OBJECT_EVENT_CLICKED, priority_,
            &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>,
         EVAS_3D_OBJECT_EVENT_CLICKED );
   }

   /// Clicked Event
   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EVAS_3D_OBJECT_EVENT_CLICKED, info));
   }

   /// Collision Event
   template <typename F>
   ::efl::eo::signal_connection
   callback_collision_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EVAS_3D_OBJECT_EVENT_COLLISION, priority_,
            &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>,
         EVAS_3D_OBJECT_EVENT_COLLISION );
   }

   /// Collision Event
   template <typename T>
   void
   callback_collision_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EVAS_3D_OBJECT_EVENT_COLLISION, info));
   }

   /// Obj is being deleted.
   template <typename F>
   ::efl::eo::signal_connection
   callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_DEL, priority_,
            &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::evas_3d_material, function_type>,
         EO_BASE_EVENT_DEL );
   }

   /// Obj is being deleted.
   template <typename T>
   void
   callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_DEL, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(EVAS_3D_MATERIAL_CLASS);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::evas_3d_material::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas_3d_object::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas_3d_material* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas_3d_material::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas_3d_object::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas_3d_material const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_3D_MATERIAL_CLASS, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas_3d_material) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas_3d_material>::value, "");


#include "evas_3d_material.eo.impl.hh"

#endif // EFL_GENERATED_EVAS_3D_MATERIAL_HH

