/// @cond EO_CXX_EO_IMPL

inline void evas::image::preload_begin() const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_preload_begin());
}

inline void evas::image::data_update_add(int x_, int y_, int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_data_update_add(x_, y_, w_, h_));
}

inline double evas::image::animated_frame_duration_get(int start_frame_, int frame_num_) const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_frame_duration_get(start_frame_, frame_num_));
   return _tmp_ret;
}

inline void evas::image::data_set(void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_data_set(data_));
}

inline void * evas::image::data_get(bool for_writing_) const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_data_get(::efl::eolian::to_c(for_writing_)));
   return _tmp_ret;
}

inline void evas::image::preload_cancel() const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_preload_cancel());
}

inline void * evas::image::data_convert(Evas_Colorspace to_cspace_) const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_data_convert(to_cspace_));
   return _tmp_ret;
}

inline bool evas::image::pixels_import(Evas_Pixel_Import_Source * pixels_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_pixels_import(pixels_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::reload() const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_reload());
}

inline double evas::image::load_dpi_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_dpi_get());
   return _tmp_ret;
}

inline void evas::image::load_dpi_set(double dpi_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_dpi_set(dpi_));
}

inline bool evas::image::source_clip_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_clip_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::source_clip_set(bool source_clip_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_source_clip_set(::efl::eolian::to_c(source_clip_)));
}

inline ::evas::object evas::image::source_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool evas::image::source_set(::evas::object src_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_set(::efl::eolian::to_c(src_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool evas::image::filled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_filled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::filled_set(bool filled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_filled_set(::efl::eolian::to_c(filled_)));
}

inline Evas_Image_Content_Hint evas::image::content_hint_get() const
{
   Evas_Image_Content_Hint _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_content_hint_get());
   return _tmp_ret;
}

inline void evas::image::content_hint_set(Evas_Image_Content_Hint hint_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_content_hint_set(hint_));
}

inline void evas::image::load_region_get(int* x_, int* y_, int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_region_get(x_, y_, w_, h_));
}

inline void evas::image::load_region_set(int x_, int y_, int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_region_set(x_, y_, w_, h_));
}

inline bool evas::image::alpha_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_alpha_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::alpha_set(bool alpha_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_alpha_set(::efl::eolian::to_c(alpha_)));
}

inline void evas::image::border_get(int* l_, int* r_, int* t_, int* b_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_get(l_, r_, t_, b_));
}

inline void evas::image::border_set(int l_, int r_, int t_, int b_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_set(l_, r_, t_, b_));
}

inline double evas::image::border_scale_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_border_scale_get());
   return _tmp_ret;
}

inline void evas::image::border_scale_set(double scale_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_scale_set(scale_));
}

inline bool evas::image::pixels_dirty_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_pixels_dirty_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::pixels_dirty_set(bool dirty_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_pixels_dirty_set(::efl::eolian::to_c(dirty_)));
}

inline const Evas_Video_Surface * evas::image::video_surface_get() const
{
   const Evas_Video_Surface * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_video_surface_get());
   return _tmp_ret;
}

inline void evas::image::video_surface_set(Evas_Video_Surface * surf_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_video_surface_set(surf_));
}

inline unsigned int evas::image::video_surface_caps_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_video_surface_caps_get());
   return _tmp_ret;
}

inline void evas::image::video_surface_caps_set(unsigned int caps_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_video_surface_caps_set(caps_));
}

inline bool evas::image::load_orientation_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_orientation_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::load_orientation_set(bool enable_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_orientation_set(::efl::eolian::to_c(enable_)));
}

inline Evas_Border_Fill_Mode evas::image::border_center_fill_get() const
{
   Evas_Border_Fill_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_border_center_fill_get());
   return _tmp_ret;
}

inline void evas::image::border_center_fill_set(Evas_Border_Fill_Mode fill_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_center_fill_set(fill_));
}

inline bool evas::image::source_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::source_visible_set(bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_source_visible_set(::efl::eolian::to_c(visible_)));
}

inline Evas_Native_Surface * evas::image::native_surface_get() const
{
   Evas_Native_Surface * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_native_surface_get());
   return _tmp_ret;
}

inline void evas::image::native_surface_set(Evas_Native_Surface * surf_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_native_surface_set(surf_));
}

inline int evas::image::load_scale_down_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_scale_down_get());
   return _tmp_ret;
}

inline void evas::image::load_scale_down_set(int scale_down_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_scale_down_set(scale_down_));
}

inline Evas_Image_Scale_Hint evas::image::scale_hint_get() const
{
   Evas_Image_Scale_Hint _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_scale_hint_get());
   return _tmp_ret;
}

inline void evas::image::scale_hint_set(Evas_Image_Scale_Hint hint_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_scale_hint_set(hint_));
}

inline bool evas::image::source_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void evas::image::source_events_set(bool source_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_source_events_set(::efl::eolian::to_c(source_)));
}

inline Evas_Colorspace evas::image::colorspace_get() const
{
   Evas_Colorspace _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_colorspace_get());
   return _tmp_ret;
}

inline void evas::image::colorspace_set(Evas_Colorspace cspace_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_colorspace_set(cspace_));
}

inline void evas::image::pixels_get_callback_set(Evas_Object_Image_Pixels_Get_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_pixels_get_callback_set(func_, data_));
}

inline void evas::image::data_copy_set(void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_data_copy_set(data_));
}

inline void evas::image::animated_frame_set(int frame_index_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_animated_frame_set(frame_index_));
}

inline bool evas::image::region_support_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_region_support_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_Load_Error evas::image::load_error_get() const
{
   Evas_Load_Error _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_error_get());
   return _tmp_ret;
}

inline int evas::image::animated_frame_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_frame_count_get());
   return _tmp_ret;
}

inline int evas::image::stride_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_stride_get());
   return _tmp_ret;
}

inline Evas_Image_Animated_Loop_Hint evas::image::animated_loop_type_get() const
{
   Evas_Image_Animated_Loop_Hint _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_loop_type_get());
   return _tmp_ret;
}

inline int evas::image::animated_loop_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_loop_count_get());
   return _tmp_ret;
}

inline Evas_3D_Scene * evas::image::scene_get() const
{
   Evas_3D_Scene * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_scene_get());
   return _tmp_ret;
}

inline void evas::image::scene_set(Evas_3D_Scene * scene_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_scene_set(scene_));
}

inline void evas::image::filter_program_set(::efl::eina::string_view program_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_filter_program_set(::efl::eolian::to_c(program_)));
}

inline void evas::image::filter_source_set(::efl::eina::string_view name_, ::efl::eo::concrete eobj_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_filter_source_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(eobj_)));
}

inline bool evas::image::filter_padding_get(int* l_, int* r_, int* t_, int* b_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_filter_padding_get(l_, r_, t_, b_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_Image_Orient evas::image::orient_get() const
{
   Evas_Image_Orient _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_orient_get());
   return _tmp_ret;
}

inline void evas::image::orient_set(Evas_Image_Orient orient_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_orient_set(orient_));
}

inline void eo_cxx::evas::image::preload_begin() const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_preload_begin());
}

inline void eo_cxx::evas::image::data_update_add(int x_, int y_, int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_data_update_add(x_, y_, w_, h_));
}

inline double eo_cxx::evas::image::animated_frame_duration_get(int start_frame_, int frame_num_) const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_frame_duration_get(start_frame_, frame_num_));
   return _tmp_ret;
}

inline void eo_cxx::evas::image::data_set(void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_data_set(data_));
}

inline void * eo_cxx::evas::image::data_get(bool for_writing_) const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_data_get(::efl::eolian::to_c(for_writing_)));
   return _tmp_ret;
}

inline void eo_cxx::evas::image::preload_cancel() const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_preload_cancel());
}

inline void * eo_cxx::evas::image::data_convert(Evas_Colorspace to_cspace_) const
{
   void * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_data_convert(to_cspace_));
   return _tmp_ret;
}

inline bool eo_cxx::evas::image::pixels_import(Evas_Pixel_Import_Source * pixels_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_pixels_import(pixels_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::reload() const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_reload());
}

inline double eo_cxx::evas::image::load_dpi_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_dpi_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::load_dpi_set(double dpi_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_dpi_set(dpi_));
}

inline bool eo_cxx::evas::image::source_clip_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_clip_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::source_clip_set(bool source_clip_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_source_clip_set(::efl::eolian::to_c(source_clip_)));
}

inline ::evas::object eo_cxx::evas::image::source_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::evas::image::source_set(::evas::object src_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_set(::efl::eolian::to_c(src_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::evas::image::filled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_filled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::filled_set(bool filled_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_filled_set(::efl::eolian::to_c(filled_)));
}

inline Evas_Image_Content_Hint eo_cxx::evas::image::content_hint_get() const
{
   Evas_Image_Content_Hint _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_content_hint_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::content_hint_set(Evas_Image_Content_Hint hint_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_content_hint_set(hint_));
}

inline void eo_cxx::evas::image::load_region_get(int* x_, int* y_, int* w_, int* h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_region_get(x_, y_, w_, h_));
}

inline void eo_cxx::evas::image::load_region_set(int x_, int y_, int w_, int h_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_region_set(x_, y_, w_, h_));
}

inline bool eo_cxx::evas::image::alpha_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_alpha_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::alpha_set(bool alpha_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_alpha_set(::efl::eolian::to_c(alpha_)));
}

inline void eo_cxx::evas::image::border_get(int* l_, int* r_, int* t_, int* b_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_get(l_, r_, t_, b_));
}

inline void eo_cxx::evas::image::border_set(int l_, int r_, int t_, int b_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_set(l_, r_, t_, b_));
}

inline double eo_cxx::evas::image::border_scale_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_border_scale_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::border_scale_set(double scale_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_scale_set(scale_));
}

inline bool eo_cxx::evas::image::pixels_dirty_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_pixels_dirty_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::pixels_dirty_set(bool dirty_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_pixels_dirty_set(::efl::eolian::to_c(dirty_)));
}

inline const Evas_Video_Surface * eo_cxx::evas::image::video_surface_get() const
{
   const Evas_Video_Surface * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_video_surface_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::video_surface_set(Evas_Video_Surface * surf_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_video_surface_set(surf_));
}

inline unsigned int eo_cxx::evas::image::video_surface_caps_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_video_surface_caps_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::video_surface_caps_set(unsigned int caps_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_video_surface_caps_set(caps_));
}

inline bool eo_cxx::evas::image::load_orientation_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_orientation_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::load_orientation_set(bool enable_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_orientation_set(::efl::eolian::to_c(enable_)));
}

inline Evas_Border_Fill_Mode eo_cxx::evas::image::border_center_fill_get() const
{
   Evas_Border_Fill_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_border_center_fill_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::border_center_fill_set(Evas_Border_Fill_Mode fill_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_border_center_fill_set(fill_));
}

inline bool eo_cxx::evas::image::source_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::source_visible_set(bool visible_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_source_visible_set(::efl::eolian::to_c(visible_)));
}

inline Evas_Native_Surface * eo_cxx::evas::image::native_surface_get() const
{
   Evas_Native_Surface * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_native_surface_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::native_surface_set(Evas_Native_Surface * surf_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_native_surface_set(surf_));
}

inline int eo_cxx::evas::image::load_scale_down_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_scale_down_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::load_scale_down_set(int scale_down_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_load_scale_down_set(scale_down_));
}

inline Evas_Image_Scale_Hint eo_cxx::evas::image::scale_hint_get() const
{
   Evas_Image_Scale_Hint _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_scale_hint_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::scale_hint_set(Evas_Image_Scale_Hint hint_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_scale_hint_set(hint_));
}

inline bool eo_cxx::evas::image::source_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_source_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::evas::image::source_events_set(bool source_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_source_events_set(::efl::eolian::to_c(source_)));
}

inline Evas_Colorspace eo_cxx::evas::image::colorspace_get() const
{
   Evas_Colorspace _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_colorspace_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::colorspace_set(Evas_Colorspace cspace_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_colorspace_set(cspace_));
}

inline void eo_cxx::evas::image::pixels_get_callback_set(Evas_Object_Image_Pixels_Get_Cb func_, void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_pixels_get_callback_set(func_, data_));
}

inline void eo_cxx::evas::image::data_copy_set(void * data_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_data_copy_set(data_));
}

inline void eo_cxx::evas::image::animated_frame_set(int frame_index_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_animated_frame_set(frame_index_));
}

inline bool eo_cxx::evas::image::region_support_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_region_support_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_Load_Error eo_cxx::evas::image::load_error_get() const
{
   Evas_Load_Error _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_load_error_get());
   return _tmp_ret;
}

inline int eo_cxx::evas::image::animated_frame_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_frame_count_get());
   return _tmp_ret;
}

inline int eo_cxx::evas::image::stride_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_stride_get());
   return _tmp_ret;
}

inline Evas_Image_Animated_Loop_Hint eo_cxx::evas::image::animated_loop_type_get() const
{
   Evas_Image_Animated_Loop_Hint _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_loop_type_get());
   return _tmp_ret;
}

inline int eo_cxx::evas::image::animated_loop_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_animated_loop_count_get());
   return _tmp_ret;
}

inline Evas_3D_Scene * eo_cxx::evas::image::scene_get() const
{
   Evas_3D_Scene * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_scene_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::scene_set(Evas_3D_Scene * scene_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_scene_set(scene_));
}

inline void eo_cxx::evas::image::filter_program_set(::efl::eina::string_view program_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_filter_program_set(::efl::eolian::to_c(program_)));
}

inline void eo_cxx::evas::image::filter_source_set(::efl::eina::string_view name_, ::efl::eo::concrete eobj_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_filter_source_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(eobj_)));
}

inline bool eo_cxx::evas::image::filter_padding_get(int* l_, int* r_, int* t_, int* b_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_filter_padding_get(l_, r_, t_, b_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Evas_Image_Orient eo_cxx::evas::image::orient_get() const
{
   Evas_Image_Orient _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::evas_obj_image_orient_get());
   return _tmp_ret;
}

inline void eo_cxx::evas::image::orient_set(Evas_Image_Orient orient_) const
{
   eo_do(_concrete_eo_ptr(), ::evas_obj_image_orient_set(orient_));
}

inline ::eo_cxx::evas::image::operator ::evas::image() const
{
   return *static_cast<::evas::image const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas::image::operator ::evas::image&()
{
   return *static_cast<::evas::image*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas::image::operator ::evas::image const&() const
{
   return *static_cast<::evas::image const*>(static_cast<void const*>(this));
}

template <typename T>
void evas_image_preload_begin_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->preload_begin();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_data_update_add_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int x_, int y_, int w_, int h_)
{
   try
      {
         static_cast<T*>(self->this_)->data_update_add(x_, y_, w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double evas_image_animated_frame_duration_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int start_frame_, int frame_num_)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->animated_frame_duration_get(start_frame_, frame_num_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_data_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->data_set(data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void * evas_image_data_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool for_writing_)
{
   void * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->data_get(::efl::eolian::to_cxx<bool>(for_writing_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_preload_cancel_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->preload_cancel();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void * evas_image_data_convert_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Colorspace to_cspace_)
{
   void * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->data_convert(to_cspace_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool evas_image_pixels_import_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Pixel_Import_Source * pixels_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->pixels_import(pixels_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_reload_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->reload();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double evas_image_load_dpi_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->load_dpi_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_load_dpi_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double dpi_)
{
   try
      {
         static_cast<T*>(self->this_)->load_dpi_set(dpi_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_source_clip_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_clip_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_source_clip_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool source_clip_)
{
   try
      {
         static_cast<T*>(self->this_)->source_clip_set(::efl::eolian::to_cxx<bool>(source_clip_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::evas::object evas_image_source_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::evas::object _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool evas_image_source_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * src_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_set(::efl::eolian::to_cxx<::evas::object>(src_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool evas_image_filled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->filled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_filled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool filled_)
{
   try
      {
         static_cast<T*>(self->this_)->filled_set(::efl::eolian::to_cxx<bool>(filled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Image_Content_Hint evas_image_content_hint_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Image_Content_Hint _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->content_hint_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_content_hint_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Image_Content_Hint hint_)
{
   try
      {
         static_cast<T*>(self->this_)->content_hint_set(hint_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_load_region_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* x_, int* y_, int* w_, int* h_)
{
   try
      {
         static_cast<T*>(self->this_)->load_region_get(x_, y_, w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_load_region_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int x_, int y_, int w_, int h_)
{
   try
      {
         static_cast<T*>(self->this_)->load_region_set(x_, y_, w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_alpha_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->alpha_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_alpha_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool alpha_)
{
   try
      {
         static_cast<T*>(self->this_)->alpha_set(::efl::eolian::to_cxx<bool>(alpha_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_border_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* l_, int* r_, int* t_, int* b_)
{
   try
      {
         static_cast<T*>(self->this_)->border_get(l_, r_, t_, b_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_border_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int l_, int r_, int t_, int b_)
{
   try
      {
         static_cast<T*>(self->this_)->border_set(l_, r_, t_, b_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double evas_image_border_scale_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->border_scale_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_border_scale_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double scale_)
{
   try
      {
         static_cast<T*>(self->this_)->border_scale_set(scale_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_pixels_dirty_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->pixels_dirty_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_pixels_dirty_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool dirty_)
{
   try
      {
         static_cast<T*>(self->this_)->pixels_dirty_set(::efl::eolian::to_cxx<bool>(dirty_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
const Evas_Video_Surface * evas_image_video_surface_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   const Evas_Video_Surface * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->video_surface_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_video_surface_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Video_Surface * surf_)
{
   try
      {
         static_cast<T*>(self->this_)->video_surface_set(surf_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
unsigned int evas_image_video_surface_caps_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   unsigned int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->video_surface_caps_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_video_surface_caps_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int caps_)
{
   try
      {
         static_cast<T*>(self->this_)->video_surface_caps_set(caps_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_load_orientation_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->load_orientation_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_load_orientation_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enable_)
{
   try
      {
         static_cast<T*>(self->this_)->load_orientation_set(::efl::eolian::to_cxx<bool>(enable_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Border_Fill_Mode evas_image_border_center_fill_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Border_Fill_Mode _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->border_center_fill_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_border_center_fill_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Border_Fill_Mode fill_)
{
   try
      {
         static_cast<T*>(self->this_)->border_center_fill_set(fill_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_source_visible_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_visible_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_source_visible_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool visible_)
{
   try
      {
         static_cast<T*>(self->this_)->source_visible_set(::efl::eolian::to_cxx<bool>(visible_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Native_Surface * evas_image_native_surface_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Native_Surface * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->native_surface_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_native_surface_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Native_Surface * surf_)
{
   try
      {
         static_cast<T*>(self->this_)->native_surface_set(surf_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int evas_image_load_scale_down_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->load_scale_down_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_load_scale_down_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int scale_down_)
{
   try
      {
         static_cast<T*>(self->this_)->load_scale_down_set(scale_down_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Image_Scale_Hint evas_image_scale_hint_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Image_Scale_Hint _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->scale_hint_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_scale_hint_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Image_Scale_Hint hint_)
{
   try
      {
         static_cast<T*>(self->this_)->scale_hint_set(hint_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_source_events_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->source_events_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_source_events_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool source_)
{
   try
      {
         static_cast<T*>(self->this_)->source_events_set(::efl::eolian::to_cxx<bool>(source_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Evas_Colorspace evas_image_colorspace_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Colorspace _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->colorspace_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_colorspace_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Colorspace cspace_)
{
   try
      {
         static_cast<T*>(self->this_)->colorspace_set(cspace_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_pixels_get_callback_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object_Image_Pixels_Get_Cb func_, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->pixels_get_callback_set(func_, data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_data_copy_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, void * data_)
{
   try
      {
         static_cast<T*>(self->this_)->data_copy_set(data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_animated_frame_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int frame_index_)
{
   try
      {
         static_cast<T*>(self->this_)->animated_frame_set(frame_index_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_region_support_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->region_support_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Evas_Load_Error evas_image_load_error_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Load_Error _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->load_error_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
int evas_image_animated_frame_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->animated_frame_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
int evas_image_stride_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->stride_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Evas_Image_Animated_Loop_Hint evas_image_animated_loop_type_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Image_Animated_Loop_Hint _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->animated_loop_type_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
int evas_image_animated_loop_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->animated_loop_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Evas_3D_Scene * evas_image_scene_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_3D_Scene * _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->scene_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_scene_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_3D_Scene * scene_)
{
   try
      {
         static_cast<T*>(self->this_)->scene_set(scene_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_filter_program_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * program_)
{
   try
      {
         static_cast<T*>(self->this_)->filter_program_set(::efl::eolian::to_cxx<::efl::eina::string_view>(program_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void evas_image_filter_source_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * name_, Eo * eobj_)
{
   try
      {
         static_cast<T*>(self->this_)->filter_source_set(::efl::eolian::to_cxx<::efl::eina::string_view>(name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eo::concrete>(eobj_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool evas_image_filter_padding_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* l_, int* r_, int* t_, int* b_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->filter_padding_get(l_, r_, t_, b_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
Evas_Image_Orient evas_image_orient_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   Evas_Image_Orient _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->orient_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void evas_image_orient_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Image_Orient orient_)
{
   try
      {
         static_cast<T*>(self->this_)->orient_set(orient_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas::image >
{
   template <typename T>
   struct type
         : virtual operations< ::evas::object >::template type<T>
         , virtual operations< ::efl::file >::template type<T>
         , virtual operations< ::efl::image >::template type<T>
         , virtual operations< ::efl::gfx::fill >::template type<T>
         , virtual operations< ::efl::gfx::view >::template type<T>
   {
      virtual void preload_begin()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_preload_begin());
      }

      virtual void data_update_add(int x_, int y_, int w_, int h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_data_update_add(x_, y_, w_, h_));
      }

      virtual double animated_frame_duration_get(int start_frame_, int frame_num_)
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_animated_frame_duration_get(start_frame_, frame_num_));
            return _tmp_ret;
      }

      virtual void data_set(void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_data_set(data_));
      }

      virtual void * data_get(bool for_writing_)
      {
         void * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_data_get(::efl::eolian::to_c(for_writing_)));
            return _tmp_ret;
      }

      virtual void preload_cancel()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_preload_cancel());
      }

      virtual void * data_convert(Evas_Colorspace to_cspace_)
      {
         void * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_data_convert(to_cspace_));
            return _tmp_ret;
      }

      virtual bool pixels_import(Evas_Pixel_Import_Source * pixels_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_pixels_import(pixels_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void reload()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_reload());
      }

      virtual double load_dpi_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_load_dpi_get());
            return _tmp_ret;
      }

      virtual void load_dpi_set(double dpi_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_load_dpi_set(dpi_));
      }

      virtual bool source_clip_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_source_clip_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void source_clip_set(bool source_clip_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_source_clip_set(::efl::eolian::to_c(source_clip_)));
      }

      virtual ::evas::object source_get()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_source_get());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool source_set(::evas::object src_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_source_set(::efl::eolian::to_c(src_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool filled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_filled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void filled_set(bool filled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_filled_set(::efl::eolian::to_c(filled_)));
      }

      virtual Evas_Image_Content_Hint content_hint_get()
      {
         Evas_Image_Content_Hint _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_content_hint_get());
            return _tmp_ret;
      }

      virtual void content_hint_set(Evas_Image_Content_Hint hint_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_content_hint_set(hint_));
      }

      virtual void load_region_get(int* x_, int* y_, int* w_, int* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_load_region_get(x_, y_, w_, h_));
      }

      virtual void load_region_set(int x_, int y_, int w_, int h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_load_region_set(x_, y_, w_, h_));
      }

      virtual bool alpha_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_alpha_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void alpha_set(bool alpha_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_alpha_set(::efl::eolian::to_c(alpha_)));
      }

      virtual void border_get(int* l_, int* r_, int* t_, int* b_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_border_get(l_, r_, t_, b_));
      }

      virtual void border_set(int l_, int r_, int t_, int b_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_border_set(l_, r_, t_, b_));
      }

      virtual double border_scale_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_border_scale_get());
            return _tmp_ret;
      }

      virtual void border_scale_set(double scale_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_border_scale_set(scale_));
      }

      virtual bool pixels_dirty_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_pixels_dirty_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void pixels_dirty_set(bool dirty_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_pixels_dirty_set(::efl::eolian::to_c(dirty_)));
      }

      virtual const Evas_Video_Surface * video_surface_get()
      {
         const Evas_Video_Surface * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_video_surface_get());
            return _tmp_ret;
      }

      virtual void video_surface_set(Evas_Video_Surface * surf_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_video_surface_set(surf_));
      }

      virtual unsigned int video_surface_caps_get()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_video_surface_caps_get());
            return _tmp_ret;
      }

      virtual void video_surface_caps_set(unsigned int caps_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_video_surface_caps_set(caps_));
      }

      virtual bool load_orientation_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_load_orientation_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void load_orientation_set(bool enable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_load_orientation_set(::efl::eolian::to_c(enable_)));
      }

      virtual Evas_Border_Fill_Mode border_center_fill_get()
      {
         Evas_Border_Fill_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_border_center_fill_get());
            return _tmp_ret;
      }

      virtual void border_center_fill_set(Evas_Border_Fill_Mode fill_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_border_center_fill_set(fill_));
      }

      virtual bool source_visible_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_source_visible_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void source_visible_set(bool visible_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_source_visible_set(::efl::eolian::to_c(visible_)));
      }

      virtual Evas_Native_Surface * native_surface_get()
      {
         Evas_Native_Surface * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_native_surface_get());
            return _tmp_ret;
      }

      virtual void native_surface_set(Evas_Native_Surface * surf_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_native_surface_set(surf_));
      }

      virtual int load_scale_down_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_load_scale_down_get());
            return _tmp_ret;
      }

      virtual void load_scale_down_set(int scale_down_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_load_scale_down_set(scale_down_));
      }

      virtual Evas_Image_Scale_Hint scale_hint_get()
      {
         Evas_Image_Scale_Hint _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_scale_hint_get());
            return _tmp_ret;
      }

      virtual void scale_hint_set(Evas_Image_Scale_Hint hint_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_scale_hint_set(hint_));
      }

      virtual bool source_events_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_source_events_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void source_events_set(bool source_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_source_events_set(::efl::eolian::to_c(source_)));
      }

      virtual Evas_Colorspace colorspace_get()
      {
         Evas_Colorspace _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_colorspace_get());
            return _tmp_ret;
      }

      virtual void colorspace_set(Evas_Colorspace cspace_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_colorspace_set(cspace_));
      }

      virtual void pixels_get_callback_set(Evas_Object_Image_Pixels_Get_Cb func_, void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_pixels_get_callback_set(func_, data_));
      }

      virtual void data_copy_set(void * data_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_data_copy_set(data_));
      }

      virtual void animated_frame_set(int frame_index_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_animated_frame_set(frame_index_));
      }

      virtual bool region_support_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_region_support_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Evas_Load_Error load_error_get()
      {
         Evas_Load_Error _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_load_error_get());
            return _tmp_ret;
      }

      virtual int animated_frame_count_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_animated_frame_count_get());
            return _tmp_ret;
      }

      virtual int stride_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_stride_get());
            return _tmp_ret;
      }

      virtual Evas_Image_Animated_Loop_Hint animated_loop_type_get()
      {
         Evas_Image_Animated_Loop_Hint _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_animated_loop_type_get());
            return _tmp_ret;
      }

      virtual int animated_loop_count_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_animated_loop_count_get());
            return _tmp_ret;
      }

      virtual Evas_3D_Scene * scene_get()
      {
         Evas_3D_Scene * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_scene_get());
            return _tmp_ret;
      }

      virtual void scene_set(Evas_3D_Scene * scene_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_scene_set(scene_));
      }

      virtual void filter_program_set(::efl::eina::string_view program_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_filter_program_set(::efl::eolian::to_c(program_)));
      }

      virtual void filter_source_set(::efl::eina::string_view name_, ::efl::eo::concrete eobj_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_filter_source_set(::efl::eolian::to_c(name_), ::efl::eolian::to_c(eobj_)));
      }

      virtual bool filter_padding_get(int* l_, int* r_, int* t_, int* b_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_filter_padding_get(l_, r_, t_, b_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Evas_Image_Orient orient_get()
      {
         Evas_Image_Orient _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_obj_image_orient_get());
            return _tmp_ret;
      }

      virtual void orient_set(Evas_Image_Orient orient_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::evas_obj_image_orient_set(orient_));
      }

   };
};


#ifdef IMAGE_PROTECTED
template<>
struct operation_description_class_size< ::evas::image >
{
   static constexpr int value = 65 + operation_description_class_size<::evas::object >::value + operation_description_class_size<::efl::file >::value + operation_description_class_size<::efl::image >::value + operation_description_class_size<::efl::gfx::fill >::value + operation_description_class_size<::efl::gfx::view >::value;
};

#else
template<>
struct operation_description_class_size< ::evas::image >
{
   static constexpr int value = 65 + operation_description_class_size<::evas::object >::value + operation_description_class_size<::efl::file >::value + operation_description_class_size<::efl::image >::value + operation_description_class_size<::efl::gfx::fill >::value + operation_description_class_size<::efl::gfx::view >::value;
};

#endif

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas::image>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_image_preload_begin_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_obj_image_preload_begin);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::evas_image_data_update_add_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_obj_image_data_update_add);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::evas_image_animated_frame_duration_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_obj_image_animated_frame_duration_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::evas_image_data_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_obj_image_data_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::evas_image_data_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_obj_image_data_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::evas_image_preload_cancel_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_obj_image_preload_cancel);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::evas_image_data_convert_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_obj_image_data_convert);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::evas_image_pixels_import_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_obj_image_pixels_import);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::evas_image_reload_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_obj_image_reload);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::evas_image_load_dpi_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_dpi_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::evas_image_load_dpi_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_dpi_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::evas_image_source_clip_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_clip_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::evas_image_source_clip_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_clip_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::evas_image_source_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::evas_image_source_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::evas_image_filled_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::evas_obj_image_filled_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::evas_image_filled_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::evas_obj_image_filled_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::evas_image_content_hint_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::evas_obj_image_content_hint_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::evas_image_content_hint_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::evas_obj_image_content_hint_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::evas_image_load_region_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_region_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::evas_image_load_region_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_region_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::evas_image_alpha_get_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::evas_obj_image_alpha_get);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::evas_image_alpha_set_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::evas_obj_image_alpha_set);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::evas_image_border_get_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::evas_obj_image_border_get);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::evas_image_border_set_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::evas_obj_image_border_set);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::evas_image_border_scale_get_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::evas_obj_image_border_scale_get);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::evas_image_border_scale_set_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::evas_obj_image_border_scale_set);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::evas_image_pixels_dirty_get_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::evas_obj_image_pixels_dirty_get);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::evas_image_pixels_dirty_set_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::evas_obj_image_pixels_dirty_set);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   ops[29].func = reinterpret_cast<void*>(& ::evas_image_video_surface_get_wrapper<T>);
   ops[29].api_func = reinterpret_cast<void*>(& ::evas_obj_image_video_surface_get);
   ops[29].op = EO_OP_OVERRIDE;
   ops[29].op_type = EO_OP_TYPE_REGULAR;
   ops[29].doc = NULL;

   ops[30].func = reinterpret_cast<void*>(& ::evas_image_video_surface_set_wrapper<T>);
   ops[30].api_func = reinterpret_cast<void*>(& ::evas_obj_image_video_surface_set);
   ops[30].op = EO_OP_OVERRIDE;
   ops[30].op_type = EO_OP_TYPE_REGULAR;
   ops[30].doc = NULL;

   ops[31].func = reinterpret_cast<void*>(& ::evas_image_video_surface_caps_get_wrapper<T>);
   ops[31].api_func = reinterpret_cast<void*>(& ::evas_obj_image_video_surface_caps_get);
   ops[31].op = EO_OP_OVERRIDE;
   ops[31].op_type = EO_OP_TYPE_REGULAR;
   ops[31].doc = NULL;

   ops[32].func = reinterpret_cast<void*>(& ::evas_image_video_surface_caps_set_wrapper<T>);
   ops[32].api_func = reinterpret_cast<void*>(& ::evas_obj_image_video_surface_caps_set);
   ops[32].op = EO_OP_OVERRIDE;
   ops[32].op_type = EO_OP_TYPE_REGULAR;
   ops[32].doc = NULL;

   ops[33].func = reinterpret_cast<void*>(& ::evas_image_load_orientation_get_wrapper<T>);
   ops[33].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_orientation_get);
   ops[33].op = EO_OP_OVERRIDE;
   ops[33].op_type = EO_OP_TYPE_REGULAR;
   ops[33].doc = NULL;

   ops[34].func = reinterpret_cast<void*>(& ::evas_image_load_orientation_set_wrapper<T>);
   ops[34].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_orientation_set);
   ops[34].op = EO_OP_OVERRIDE;
   ops[34].op_type = EO_OP_TYPE_REGULAR;
   ops[34].doc = NULL;

   ops[35].func = reinterpret_cast<void*>(& ::evas_image_border_center_fill_get_wrapper<T>);
   ops[35].api_func = reinterpret_cast<void*>(& ::evas_obj_image_border_center_fill_get);
   ops[35].op = EO_OP_OVERRIDE;
   ops[35].op_type = EO_OP_TYPE_REGULAR;
   ops[35].doc = NULL;

   ops[36].func = reinterpret_cast<void*>(& ::evas_image_border_center_fill_set_wrapper<T>);
   ops[36].api_func = reinterpret_cast<void*>(& ::evas_obj_image_border_center_fill_set);
   ops[36].op = EO_OP_OVERRIDE;
   ops[36].op_type = EO_OP_TYPE_REGULAR;
   ops[36].doc = NULL;

   ops[37].func = reinterpret_cast<void*>(& ::evas_image_source_visible_get_wrapper<T>);
   ops[37].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_visible_get);
   ops[37].op = EO_OP_OVERRIDE;
   ops[37].op_type = EO_OP_TYPE_REGULAR;
   ops[37].doc = NULL;

   ops[38].func = reinterpret_cast<void*>(& ::evas_image_source_visible_set_wrapper<T>);
   ops[38].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_visible_set);
   ops[38].op = EO_OP_OVERRIDE;
   ops[38].op_type = EO_OP_TYPE_REGULAR;
   ops[38].doc = NULL;

   ops[39].func = reinterpret_cast<void*>(& ::evas_image_native_surface_get_wrapper<T>);
   ops[39].api_func = reinterpret_cast<void*>(& ::evas_obj_image_native_surface_get);
   ops[39].op = EO_OP_OVERRIDE;
   ops[39].op_type = EO_OP_TYPE_REGULAR;
   ops[39].doc = NULL;

   ops[40].func = reinterpret_cast<void*>(& ::evas_image_native_surface_set_wrapper<T>);
   ops[40].api_func = reinterpret_cast<void*>(& ::evas_obj_image_native_surface_set);
   ops[40].op = EO_OP_OVERRIDE;
   ops[40].op_type = EO_OP_TYPE_REGULAR;
   ops[40].doc = NULL;

   ops[41].func = reinterpret_cast<void*>(& ::evas_image_load_scale_down_get_wrapper<T>);
   ops[41].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_scale_down_get);
   ops[41].op = EO_OP_OVERRIDE;
   ops[41].op_type = EO_OP_TYPE_REGULAR;
   ops[41].doc = NULL;

   ops[42].func = reinterpret_cast<void*>(& ::evas_image_load_scale_down_set_wrapper<T>);
   ops[42].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_scale_down_set);
   ops[42].op = EO_OP_OVERRIDE;
   ops[42].op_type = EO_OP_TYPE_REGULAR;
   ops[42].doc = NULL;

   ops[43].func = reinterpret_cast<void*>(& ::evas_image_scale_hint_get_wrapper<T>);
   ops[43].api_func = reinterpret_cast<void*>(& ::evas_obj_image_scale_hint_get);
   ops[43].op = EO_OP_OVERRIDE;
   ops[43].op_type = EO_OP_TYPE_REGULAR;
   ops[43].doc = NULL;

   ops[44].func = reinterpret_cast<void*>(& ::evas_image_scale_hint_set_wrapper<T>);
   ops[44].api_func = reinterpret_cast<void*>(& ::evas_obj_image_scale_hint_set);
   ops[44].op = EO_OP_OVERRIDE;
   ops[44].op_type = EO_OP_TYPE_REGULAR;
   ops[44].doc = NULL;

   ops[45].func = reinterpret_cast<void*>(& ::evas_image_source_events_get_wrapper<T>);
   ops[45].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_events_get);
   ops[45].op = EO_OP_OVERRIDE;
   ops[45].op_type = EO_OP_TYPE_REGULAR;
   ops[45].doc = NULL;

   ops[46].func = reinterpret_cast<void*>(& ::evas_image_source_events_set_wrapper<T>);
   ops[46].api_func = reinterpret_cast<void*>(& ::evas_obj_image_source_events_set);
   ops[46].op = EO_OP_OVERRIDE;
   ops[46].op_type = EO_OP_TYPE_REGULAR;
   ops[46].doc = NULL;

   ops[47].func = reinterpret_cast<void*>(& ::evas_image_colorspace_get_wrapper<T>);
   ops[47].api_func = reinterpret_cast<void*>(& ::evas_obj_image_colorspace_get);
   ops[47].op = EO_OP_OVERRIDE;
   ops[47].op_type = EO_OP_TYPE_REGULAR;
   ops[47].doc = NULL;

   ops[48].func = reinterpret_cast<void*>(& ::evas_image_colorspace_set_wrapper<T>);
   ops[48].api_func = reinterpret_cast<void*>(& ::evas_obj_image_colorspace_set);
   ops[48].op = EO_OP_OVERRIDE;
   ops[48].op_type = EO_OP_TYPE_REGULAR;
   ops[48].doc = NULL;

   ops[49].func = reinterpret_cast<void*>(& ::evas_image_pixels_get_callback_set_wrapper<T>);
   ops[49].api_func = reinterpret_cast<void*>(& ::evas_obj_image_pixels_get_callback_set);
   ops[49].op = EO_OP_OVERRIDE;
   ops[49].op_type = EO_OP_TYPE_REGULAR;
   ops[49].doc = NULL;

   ops[50].func = reinterpret_cast<void*>(& ::evas_image_data_copy_set_wrapper<T>);
   ops[50].api_func = reinterpret_cast<void*>(& ::evas_obj_image_data_copy_set);
   ops[50].op = EO_OP_OVERRIDE;
   ops[50].op_type = EO_OP_TYPE_REGULAR;
   ops[50].doc = NULL;

   ops[51].func = reinterpret_cast<void*>(& ::evas_image_animated_frame_set_wrapper<T>);
   ops[51].api_func = reinterpret_cast<void*>(& ::evas_obj_image_animated_frame_set);
   ops[51].op = EO_OP_OVERRIDE;
   ops[51].op_type = EO_OP_TYPE_REGULAR;
   ops[51].doc = NULL;

   ops[52].func = reinterpret_cast<void*>(& ::evas_image_region_support_get_wrapper<T>);
   ops[52].api_func = reinterpret_cast<void*>(& ::evas_obj_image_region_support_get);
   ops[52].op = EO_OP_OVERRIDE;
   ops[52].op_type = EO_OP_TYPE_REGULAR;
   ops[52].doc = NULL;

   ops[53].func = reinterpret_cast<void*>(& ::evas_image_load_error_get_wrapper<T>);
   ops[53].api_func = reinterpret_cast<void*>(& ::evas_obj_image_load_error_get);
   ops[53].op = EO_OP_OVERRIDE;
   ops[53].op_type = EO_OP_TYPE_REGULAR;
   ops[53].doc = NULL;

   ops[54].func = reinterpret_cast<void*>(& ::evas_image_animated_frame_count_get_wrapper<T>);
   ops[54].api_func = reinterpret_cast<void*>(& ::evas_obj_image_animated_frame_count_get);
   ops[54].op = EO_OP_OVERRIDE;
   ops[54].op_type = EO_OP_TYPE_REGULAR;
   ops[54].doc = NULL;

   ops[55].func = reinterpret_cast<void*>(& ::evas_image_stride_get_wrapper<T>);
   ops[55].api_func = reinterpret_cast<void*>(& ::evas_obj_image_stride_get);
   ops[55].op = EO_OP_OVERRIDE;
   ops[55].op_type = EO_OP_TYPE_REGULAR;
   ops[55].doc = NULL;

   ops[56].func = reinterpret_cast<void*>(& ::evas_image_animated_loop_type_get_wrapper<T>);
   ops[56].api_func = reinterpret_cast<void*>(& ::evas_obj_image_animated_loop_type_get);
   ops[56].op = EO_OP_OVERRIDE;
   ops[56].op_type = EO_OP_TYPE_REGULAR;
   ops[56].doc = NULL;

   ops[57].func = reinterpret_cast<void*>(& ::evas_image_animated_loop_count_get_wrapper<T>);
   ops[57].api_func = reinterpret_cast<void*>(& ::evas_obj_image_animated_loop_count_get);
   ops[57].op = EO_OP_OVERRIDE;
   ops[57].op_type = EO_OP_TYPE_REGULAR;
   ops[57].doc = NULL;

   ops[58].func = reinterpret_cast<void*>(& ::evas_image_scene_get_wrapper<T>);
   ops[58].api_func = reinterpret_cast<void*>(& ::evas_obj_image_scene_get);
   ops[58].op = EO_OP_OVERRIDE;
   ops[58].op_type = EO_OP_TYPE_REGULAR;
   ops[58].doc = NULL;

   ops[59].func = reinterpret_cast<void*>(& ::evas_image_scene_set_wrapper<T>);
   ops[59].api_func = reinterpret_cast<void*>(& ::evas_obj_image_scene_set);
   ops[59].op = EO_OP_OVERRIDE;
   ops[59].op_type = EO_OP_TYPE_REGULAR;
   ops[59].doc = NULL;

   ops[60].func = reinterpret_cast<void*>(& ::evas_image_filter_program_set_wrapper<T>);
   ops[60].api_func = reinterpret_cast<void*>(& ::evas_obj_image_filter_program_set);
   ops[60].op = EO_OP_OVERRIDE;
   ops[60].op_type = EO_OP_TYPE_REGULAR;
   ops[60].doc = NULL;

   ops[61].func = reinterpret_cast<void*>(& ::evas_image_filter_source_set_wrapper<T>);
   ops[61].api_func = reinterpret_cast<void*>(& ::evas_obj_image_filter_source_set);
   ops[61].op = EO_OP_OVERRIDE;
   ops[61].op_type = EO_OP_TYPE_REGULAR;
   ops[61].doc = NULL;

   ops[62].func = reinterpret_cast<void*>(& ::evas_image_filter_padding_get_wrapper<T>);
   ops[62].api_func = reinterpret_cast<void*>(& ::evas_obj_image_filter_padding_get);
   ops[62].op = EO_OP_OVERRIDE;
   ops[62].op_type = EO_OP_TYPE_REGULAR;
   ops[62].doc = NULL;

   ops[63].func = reinterpret_cast<void*>(& ::evas_image_orient_get_wrapper<T>);
   ops[63].api_func = reinterpret_cast<void*>(& ::evas_obj_image_orient_get);
   ops[63].op = EO_OP_OVERRIDE;
   ops[63].op_type = EO_OP_TYPE_REGULAR;
   ops[63].doc = NULL;

   ops[64].func = reinterpret_cast<void*>(& ::evas_image_orient_set_wrapper<T>);
   ops[64].api_func = reinterpret_cast<void*>(& ::evas_obj_image_orient_set);
   ops[64].op = EO_OP_OVERRIDE;
   ops[64].op_type = EO_OP_TYPE_REGULAR;
   ops[64].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::object>(), &ops[operation_description_class_size< ::evas::image >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::file>(), &ops[operation_description_class_size< ::evas::image >::value + operation_description_class_size<::evas::object>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::image>(), &ops[operation_description_class_size< ::evas::image >::value + operation_description_class_size<::evas::object>::value + operation_description_class_size<::efl::file>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::gfx::fill>(), &ops[operation_description_class_size< ::evas::image >::value + operation_description_class_size<::evas::object>::value + operation_description_class_size<::efl::file>::value + operation_description_class_size<::efl::image>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::gfx::view>(), &ops[operation_description_class_size< ::evas::image >::value + operation_description_class_size<::evas::object>::value + operation_description_class_size<::efl::file>::value + operation_description_class_size<::efl::image>::value + operation_description_class_size<::efl::gfx::fill>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::evas::image>)
{
   return (EVAS_IMAGE_CLASS);
}

} } }

/// @endcond

